Option Explicit On
Option Strict On

Imports System.IO

' link original del ejemplo en c# :
' http://jmarcost.blogspot.com/2007/03/un-combobox-con-imgenes.html

Public Class Form1

    Private Sub ComboBox1_DrawItem( _
        ByVal sender As Object, _
        ByVal e As System.Windows.Forms.DrawItemEventArgs) _
            Handles ComboBox1.DrawItem

        Const Padding_Left As Integer = 5

        Dim item As Comboitem = CType(ComboBox1.Items(e.Index), Comboitem)

        e.DrawBackground()


        Dim indice As Integer = item.ImageIndex

        If (indice >= 0 And indice < ImageList1.Images.Count) Then

            ' dibujar la imagen con DrawImage
            e.Graphics.DrawImage( _
                ImageList1.Images(indice), _
                New PointF(e.Bounds.Left + Padding_Left, e.Bounds.Top))

            ' dibujar el texto del item con el mtodo DrawString
            e.Graphics.DrawString( _
                item.texto, _
                e.Font, _
                New SolidBrush(e.ForeColor), _
                New PointF(Padding_Left + e.Bounds.Left + (ImageList1.ImageSize.Width + 1), e.Bounds.Top))
        End If
    End Sub


    Public Class Comboitem

        Private _imageIndex As Integer
        Private _texto As String

        Public Property texto() As String
            Get
                Return _texto
            End Get

            Set(ByVal value As String)
                _texto = value
            End Set

        End Property

        Public Property ImageIndex() As Integer
            Get
                Return _imageIndex
            End Get

            Set(ByVal value As Integer)
                _imageIndex = value
            End Set
        End Property

        Sub New(ByVal texto As String, ByVal imageIndex As Integer)
            _texto = texto
            _imageIndex = imageIndex
        End Sub

        Public Overrides Function ToString() As String
            Return texto
        End Function
    End Class

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Try

            With ComboBox1

                .DrawMode = DrawMode.OwnerDrawFixed

                For Each Drive As DriveInfo In System.IO.DriveInfo.GetDrives

                    Dim index As Integer = 0
                    Select Case Drive.DriveType
                        Case DriveType.CDRom : index = 2
                        Case DriveType.Network : index = 3
                        Case DriveType.Fixed : index = 1
                        Case DriveType.Ram : index = 1
                        Case DriveType.Unknown : index = 1
                        Case DriveType.Removable : index = 0
                    End Select

                    ComboBox1.Items.Add(New Comboitem(Drive.Name, index))


                Next
            End With
        Catch ex As Exception
            MsgBox(ex.Message.ToString)
        End Try
    End Sub
End Class
